---
title: Full content type update
slug: graph/api/full-content-type-update
docTags: 
createdAt: 2026-08-28T18:28:55.472Z
---

{
  "id": "i2tXuNd1sphh880w09P13",
  "type": "api-oas-v2",
  "data": {
    "method": "PUT",
    "url": "https://cg.optimizely.com/api/content/v3/types",
    "servers": [
      {
        "url": "https://cg.optimizely.com/api/content/v3/types"
      }
    ],
    "name": "Full content type update",
    "description": "<p>Update content types of the source (overwrite all)</p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "id",
          "type": "string",
          "description": "The id of the source",
          "default": "default"
        }
      ],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "example": "{\"label\":\"Weather Forecast\",\"description\":\"The description of source\",\"languages\":[\"en\"],\"links\":{},\"contentTypes\":{\"Weather\":{\"contentType\":[],\"properties\":{\"Location\":{\"type\":\"Location\"},\"Description\":{\"type\":\"String\"},\"Temperature\":{\"type\":\"Int\"}}}},\"propertyTypes\":{\"Location\":{\"properties\":{\"Latitude\":{\"type\":\"Float\"},\"Longitude\":{\"type\":\"Float\"}}}}}",
          "description": "Content type definitions",
          "customType": "ContentSource_V3",
          "schema": [
            {
              "name": "preset",
              "kind": "optional",
              "type": "string",
              "description": "",
              "modelRef": "#/components/schemas/Preset",
              "customType": "Preset",
              "schema": []
            },
            {
              "name": "useTypedFieldNames",
              "kind": "optional",
              "type": "boolean",
              "description": ""
            },
            {
              "name": "description",
              "kind": "optional",
              "type": "string",
              "nullable": true,
              "description": "",
              "modelRef": "#/components/schemas/Optional_string_",
              "customType": "Optional_string_",
              "schema": []
            },
            {
              "name": "label",
              "kind": "optional",
              "type": "string",
              "nullable": true,
              "description": "",
              "modelRef": "#/components/schemas/Optional_string_",
              "customType": "Optional_string_",
              "schema": []
            },
            {
              "name": "links",
              "kind": "optional",
              "type": "object",
              "description": "",
              "modelRef": "#/components/schemas/LinkMap",
              "customType": "LinkMap",
              "schema": []
            },
            {
              "name": "propertyTypes",
              "kind": "optional",
              "type": "object",
              "description": "",
              "modelRef": "#/components/schemas/PropertyTypeMap_V3",
              "customType": "PropertyTypeMap_V3",
              "schema": []
            },
            {
              "name": "contentTypes",
              "kind": "optional",
              "type": "object",
              "description": "",
              "modelRef": "#/components/schemas/ContentTypeMap_V3",
              "customType": "ContentTypeMap_V3",
              "schema": []
            },
            {
              "name": "languages",
              "kind": "optional",
              "type": "array",
              "description": "",
              "example": "",
              "default": [],
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            }
          ],
          "modelRef": "#/components/schemas/ContentSource_V3",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "epi-hmac",
          "name": "Authorization",
          "kind": "optional",
          "type": "apiKey",
          "description": "<p>HMAC authentication (<code>epi-hmac xxx</code>)</p>",
          "in": "header"
        },
        {
          "id": "Bearer",
          "name": "Bearer",
          "kind": "optional",
          "type": "http",
          "description": "JWT token",
          "scheme": "bearer"
        },
        {
          "id": "Basic",
          "name": "Basic",
          "kind": "optional",
          "type": "http",
          "description": "HMAC credentials",
          "scheme": "basic"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "204",
        "description": "No content",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "w0OoDw-74q-HGQKHDDC49",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request PUT \\\n     --url 'https://cg.optimizely.com/api/content/v3/types?id=default' \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"languages\": []\n     }'"
        },
        {
          "id": "MM_t3k7N2N6WiMLcFWi-D",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"languages\": []\n});\n\nvar requestOptions = {\n   method: 'PUT',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://cg.optimizely.com/api/content/v3/types?id=default\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "RVgcAKhGKF6ZKx73pDPRx",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://cg.optimizely.com/api/content/v3/types?id=default\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Put.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"languages\": []\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "OZOrpXSM-kmLwzXdzw0Xs",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://cg.optimizely.com/api/content/v3/types?id=default\"\n\npayload = json.dumps({\n   \"languages\": []\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"PUT\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "w0OoDw-74q-HGQKHDDC49"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-204",
          "language": "204",
          "code": "// No content\n"
        }
      ],
      "selectedLanguageId": "response-0-204"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}